unit mainform;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdHTTP, IdMultipartFormData, OleCtrls, SHDocVw;

type
  TForm1 = class(TForm)
    IdHTTP1: TIdHTTP;
    Edit1: TEdit;
    OpenDialog1: TOpenDialog;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Memo1: TMemo;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Edit1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  fullpath: string;

implementation

{$R *.dfm}

//    ,      ? -1
function GetFileSize(FileName: String): Integer;
var
  FS: TFileStream;
begin
  try
    FS := TFileStream.Create(Filename, fmOpenRead);
  except
    Result := -1;
  end;
  if Result <> -1 then Result := FS.Size;
  FS.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
var response: string;
    formData: TIdMultiPartFormDataStream;
begin
  Label3.Caption:='...';
  if (FileExists(fullpath)=true) then
  begin
    Button1.Enabled:=false;
    Edit1.Text:='   ...';
    Application.ProcessMessages();
    Label3.Caption:='0 bytes';
    formData := TIdMultiPartFormDataStream.Create;
    formData.AddFile('userfile', fullpath, 'application/octet-stream');
    formData.AddFormField('param1', 'value1');
    //HttpObject.Port := Port;
    response := idHTTP1.Post(Edit2.Text, formData);
    memo1.Lines.Add(response);
  end;
end;

procedure TForm1.Edit1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key=27 then close;
end;

procedure TForm1.Edit1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if OpenDialog1.Execute then
  begin
    if (FileExists(OpenDialog1.FileName)=true) then
    begin
      memo1.Lines.Clear;
      fullpath:=OpenDialog1.FileName;
      edit1.Text:=ExtractFileName(fullpath);
      //showmessage(' :'+#10#13+fullpath);
      Label3.Caption:=inttostr(GetFileSize(fullpath))+' bytes';
      Button1.Enabled:=true;
      Button1.SetFocus;
    end else Button1.Enabled:=false;
  end;
  if (Button1.Enabled=false) then edit2.SetFocus;
end;

end.
